#include <stdio.h>
#include <math.h>

#define N 4000

  int
  isprime(int);

  int
  goldbach(int);

  main(){
    int i;
    int numpairs[N];
    int conject=1;

    /*
     *   1. Create a for loop (i=1;i<=N;i++) and set numpairs[i-1] to the 
     *      returned value of a function goldbach, which returns the number
     *      of Goldbach pairs for the given even number 2*i
     */

    /*
     *   2. See function goldbach below
     */


    /*
     *   3. Check that the conjecture holds true for the first N even
     *     numbers, ie that there is at least one Goldbach pair for
     *     each even number
     */

    /* 
     *  4. Output selected results
     */

    for (i=0; i<N; i+=N/10) { printf("%d, %d\n",2*(i+1),numpairs[i]); }

    exit(0);
  }

/*
 *   Function goldbach : Calculates the number of Goldbach pairs for
 *   a given even number and returns the number of pairs
 */

  int
  goldbach(int evenno){
    int j;
    int numpairs=0;

    for (j=2; j<=evenno/2; j++)
      if (isprime(j)&&isprime(evenno-j)) numpairs++;


    return(numpairs);

  }

/*
 *   Function isprime : Returns 1 if number is prime, 0 otherwise
 */
  int
  isprime(int num){
    int i;
    int test;

  /*
   *  Crude primality test: Check all integers less than square root of number
   */

    if (num==1) return(0); 
    test=1;
    i=2;
    while ((i<=(int)sqrt((float)num))&&(test)) {
      test=(fmod(num,i)!=0);
      i++;
    }

    return(test);
  }
