#include <stdio.h>
#include <stdlib.h>
#include <math.h>

# define npoints 1000
# define MAXITER 10000

float uni (void);
void rinit (int);

  struct complex{
      double creal;
      double cimag;
  };

  main(){
    int i, j, numinside;
    double area, error;
    struct complex z, c[npoints];

/*
 *  Generate npoints random points in the complex plane
 */

    rinit (54321);
    for (i=0; i<npoints; i++) {
        c[i].creal = -2.0+2.5*uni();
        c[i].cimag = 1.125*uni();
    }

/*
 *   Monte Carlo sampling 
 *
 *     Outer loop runs over npoints, initialise z=c
 *
 *     Inner loop has the iteration z=z*z+c, and threshold test
 */


/*
 *  Calculate area and error and output the Results
 */

    area=2.0*2.5*1.125*(double)numinside/(double)npoints;
    error=area/sqrt((double)npoints);

    printf("Area of Mandlebrot set = %16.12f +/- %16.12f\n",area,error);

  }
