c     
      implicit double precision (a-h, o-z)
      parameter (mm = 10)
      parameter (npart = 4*mm*mm*mm)
      real*4 secnds
c     
      dimension  x(1:npart,1:3), vh(1:npart,1:3),f(1:npart,1:3)
c     
c     parameter definition (density, volume, temperature ...)
c     
      den = 0.83134d0
      side = (dfloat(npart) / den)**0.3333333d0
      tref = 0.722d0
      rcoff = dfloat(mm) / 4.0d0
      h = 0.064d0
      irep = 10
      istop = 20
      iprint = 5
      movemx = 20
c
      write(6,1) npart,side,rcoff,tref,h,irep,istop,
     &     iprint,movemx
 1    format(' molecular dynamics simulation example program'/
     &     ' ---------------------------------------------'//
     &     ' number of particles is ............ ',i6/
     &     ' side length of the box is ......... ',f13.6/
     &     ' cut off is ........................ ',f13.6/
     &     ' reduced temperature is ............ ',f13.6/
     &     ' basic time step is ................ ',f13.6/
     &     ' temperature scale interval ........ ',i6/
     &     ' stop scaling at move .............. ',i6/
     &     ' print interval .................... ',i6/
     &     ' total no. of steps ................ ',i6)
      call flush(6)
c     
      a = side / dfloat(mm)
      sideh = side * 0.5d0
      hsq = h * h
      hsq2 = hsq * 0.5d0
      npartm = npart - 1
      rcoffs = rcoff * rcoff
      tscale = 16.0d0 / (1.0d0 * npart - 1.0d0)
      vaver = 1.13d0 * sqrt(tref / 24.0d0)
c     
c     generate fcc lattice for atoms inside box
c     
      call fcc(x, npart, mm, a)
c     
c     initialise velocites and forces (which are zero in fcc positions)
c     
      call mxwell(vh,3*npart,h,tref)
      call dfill(3*npart, 0.0d0, f, 1)
c     
c     start of md. 
c     
      write(6,3)
 3    format(//1x,'   i  ','     ke    ','      pe     ','      e     ',
     &     '    temp   ','   pres   ','   vel    ','  rp'/
     &     1x,' -----',3('  ----------'),3('  --------'),'  ----')
      call flush(6)
      start = secnds(0.)
c  
      do 200 move = 1,movemx
c     
c     move the particles and partially update velocities
c     
         call domove(3*npart,x,vh,f,side)
c     
c     compute forces in the new positions and accumulate the 
c     virial and potential energy.
c     
         call forces(npart, x, f, vir, epot, side, rcoff)
c
c     scale forces, complete update of velocites and compute k.e.
c
         call mkekin(npart,f,vh,hsq2,hsq,ekin)
c
c     average the velocity and temperature scale if desired
c
         call velavg(npart, vh, vaver, count, vel, h)
         if ((move.lt.istop) .and. (mod(move, irep).eq.0)) then
            sc = sqrt( tref / (tscale * ekin) )
            call dscal(3*npart, sc, vh, 1)
            ekin = tref / tscale
         endif
c
c     sum to get full potential energy and virial
c
         if (mod(move, iprint) .eq. 0) then
            call prnout(move, ekin, epot, tscale, vir, vel, count,
     $           npart, den)
         endif
c
 200  continue
      time = secnds(0.) - start
      write(6,*) ' ' 
      write(6,*) 'Time = ', real(time) 
c
      end

