      subroutine forces(npart, x, f, vir, epot, side, rcoff)
      implicit double precision (a-h, o-z)
      dimension x(npart, 3), f(npart, 3)
c     
c     compute forces and accumulate the virial and potential.
c     
      vir = 0.0d0
      epot = 0.0d0
      sideh = 0.5d0*side
      rcoffs = rcoff*rcoff
c
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,xi,yi,zi,fxi,fyi,fzi,
!$OMP&  xx,yy,zz,rd,rrd,rrd2,rrd3,rrd4,rrd6,rrd7,r148,forcex,
!$OMP&  forcey,forcez) reduction(-:vir) reduction(+:epot)
      do 270 i = 1,npart
         xi = x(i,1)
         yi = x(i,2)
         zi = x(i,3)
         fxi = 0.0d0
         fyi = 0.0d0
         fzi = 0.0d0
         do 280 j = i+1,npart
            xx = xi - x(j,1)
            yy = yi - x(j,2)
            zz = zi - x(j,3)
            if (xx .lt. -sideh) xx = xx + side
            if (xx .gt.  sideh) xx = xx - side
            if (yy .lt. -sideh) yy = yy + side
            if (yy .gt.  sideh) yy = yy - side
            if (zz .lt. -sideh) zz = zz + side
            if (zz .gt.  sideh) zz = zz - side
            rd = xx*xx + yy*yy + zz*zz
c            rdtemp(j) = rd
            if (rd .le. rcoffs) then
               rrd = 1.0d0/rd
               rrd2 = rrd*rrd
               rrd3 = rrd2*rrd
               rrd4 = rrd2*rrd2
               rrd6 = rrd2*rrd4
               rrd7 = rrd6*rrd
               epot = epot + (rrd6 - rrd3)
               r148 = rrd7 - 0.5d0*rrd4
               vir = vir - rd*r148
               forcex = xx * r148
               fxi = fxi + forcex
!$OMP ATOMIC
               f(j,1) = f(j,1) - forcex
               forcey = yy * r148
               fyi = fyi + forcey
!$OMP ATOMIC
               f(j,2) = f(j,2) - forcey
               forcez = zz * r148
               fzi = fzi + forcez
!$OMP ATOMIC
               f(j,3) = f(j,3) - forcez
            endif
 280     continue
!$OMP ATOMIC
         f(i,1) = f(i,1) + fxi
!$OMP ATOMIC
         f(i,2) = f(i,2) + fyi
!$OMP ATOMIC
         f(i,3) = f(i,3) + fzi
 270  continue
c
      end
